/* compile.c
	P.Chongstitvatana
	19 Aug 97
	1 Sept 97
*/

#include "compile.h"

extern int DS;              /* from dcl.c  */
extern int PID;
extern int CP;

FILE *FI, *FO;

expect( int tktype, char *mess )
{
  if( tok != tktype ) seterror(mess);
}

seterror( char *mess )
{
/*  printf("line %d ",line);
  switch( tok ) {
  case tkIDENTIFIER :
  case tkNUMBER :  printf("near '%s' : %s\n",tokstring,mess); break;
  default :	   printf(": %s\n",mess);
  }
*/
  printf("line %d near '%s' : %s\n",line,tokstring,mess);
  exit(-1);
}

main( int argc, char *argv[] )
{
  extern FILE *FI,*FO;
  char source[80], code[80], list[80];
  char name[80], *fname;
  static char tmp[] = "tmp000.bak";

  if( argc < 2 ) {
    printf("usage : compile source\n");
    exit(-1);
  }
  strcpy(source,argv[1]);
  strcpy(name,source);
  fname = strtok(name,".");
  if( fname == NULL ) fname = name;
  strcpy(code,fname);
  strcat(code,".out");
  strcpy(list,fname);
  strcat(list,".lst");

  FI = fopen(source,"rt");
  if( FI == NULL ) {
    printf("cannot open source : %s\n",source);
    exit(-1);
  }
  FO = fopen(tmp,"wt");

  initCharType();
  getch();
  pass1();
  fclose(FI);
  fclose(FO);
  FI = fopen(tmp,"rt");
  getch();
  pass2();
  fclose(FI);
  reName();
/*
  dumpSymTab();
*/
  FO = fopen(code,"wb");
  writeHead(FO,CP,DS,PID);
  dumpCode();
  fclose(FO);
  FO = fopen(list,"wt");
  showCode();
  fclose(FO);
}

